using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace dipl_rad_1589
{
	/// <summary>
	/// Forma za biranje osnovnih postavki programa
	/// </summary>
	public class FormPostavke : System.Windows.Forms.Form
	{
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.NumericUpDown numericUpDown2;
		private System.Windows.Forms.NumericUpDown numericUpDown3;
		private System.Windows.Forms.NumericUpDown numericUpDown4;
		private System.Windows.Forms.NumericUpDown numericUpDown5;
		private System.Windows.Forms.NumericUpDown numericUpDown6;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button button1;
		
		Solver solv;

		public FormPostavke(Solver solv)
		{
			InitializeComponent();

			// Nacini solv iz Form1 dostupnim metodama ove klase
			this.solv = solv;

			// Popuni elemente ovog prozora trenutnim vrijednostima iz solv-a
			numericUpDown1.Value = (decimal)solv.deltaT;
			numericUpDown2.Value = (decimal)solv.Re;
			numericUpDown3.Value = (decimal)solv.velUndRelax;
			numericUpDown4.Value = (decimal)solv.pUndRel;
			numericUpDown5.Value = (decimal)solv.maxIteracija;
			numericUpDown6.Value = (decimal)solv.convergenceCondition;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown2 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown3 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown4 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown5 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown6 = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown6)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.DecimalPlaces = 3;
			this.numericUpDown1.Increment = new System.Decimal(new int[] {
																			 1,
																			 0,
																			 0,
																			 196608});
			this.numericUpDown1.Location = new System.Drawing.Point(160, 32);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   196608});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown1.TabIndex = 0;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 5,
																		 0,
																		 0,
																		 196608});
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// numericUpDown2
			// 
			this.numericUpDown2.Increment = new System.Decimal(new int[] {
																			 20,
																			 0,
																			 0,
																			 0});
			this.numericUpDown2.Location = new System.Drawing.Point(152, 24);
			this.numericUpDown2.Maximum = new System.Decimal(new int[] {
																		   10000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Minimum = new System.Decimal(new int[] {
																		   20,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Name = "numericUpDown2";
			this.numericUpDown2.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown2.TabIndex = 1;
			this.numericUpDown2.Value = new System.Decimal(new int[] {
																		 400,
																		 0,
																		 0,
																		 0});
			this.numericUpDown2.ValueChanged += new System.EventHandler(this.numericUpDown2_ValueChanged);
			// 
			// numericUpDown3
			// 
			this.numericUpDown3.DecimalPlaces = 2;
			this.numericUpDown3.Increment = new System.Decimal(new int[] {
																			 5,
																			 0,
																			 0,
																			 131072});
			this.numericUpDown3.Location = new System.Drawing.Point(152, 24);
			this.numericUpDown3.Maximum = new System.Decimal(new int[] {
																		   10,
																		   0,
																		   0,
																		   65536});
			this.numericUpDown3.Minimum = new System.Decimal(new int[] {
																		   30,
																		   0,
																		   0,
																		   131072});
			this.numericUpDown3.Name = "numericUpDown3";
			this.numericUpDown3.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown3.TabIndex = 2;
			this.numericUpDown3.Value = new System.Decimal(new int[] {
																		 60,
																		 0,
																		 0,
																		 131072});
			this.numericUpDown3.ValueChanged += new System.EventHandler(this.numericUpDown3_ValueChanged);
			// 
			// numericUpDown4
			// 
			this.numericUpDown4.DecimalPlaces = 2;
			this.numericUpDown4.Increment = new System.Decimal(new int[] {
																			 5,
																			 0,
																			 0,
																			 131072});
			this.numericUpDown4.Location = new System.Drawing.Point(152, 72);
			this.numericUpDown4.Maximum = new System.Decimal(new int[] {
																		   100,
																		   0,
																		   0,
																		   131072});
			this.numericUpDown4.Minimum = new System.Decimal(new int[] {
																		   20,
																		   0,
																		   0,
																		   131072});
			this.numericUpDown4.Name = "numericUpDown4";
			this.numericUpDown4.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown4.TabIndex = 3;
			this.numericUpDown4.Value = new System.Decimal(new int[] {
																		 50,
																		 0,
																		 0,
																		 131072});
			this.numericUpDown4.ValueChanged += new System.EventHandler(this.numericUpDown4_ValueChanged);
			// 
			// numericUpDown5
			// 
			this.numericUpDown5.Increment = new System.Decimal(new int[] {
																			 10,
																			 0,
																			 0,
																			 0});
			this.numericUpDown5.Location = new System.Drawing.Point(160, 80);
			this.numericUpDown5.Maximum = new System.Decimal(new int[] {
																		   1000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown5.Minimum = new System.Decimal(new int[] {
																		   50,
																		   0,
																		   0,
																		   0});
			this.numericUpDown5.Name = "numericUpDown5";
			this.numericUpDown5.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown5.TabIndex = 4;
			this.numericUpDown5.Value = new System.Decimal(new int[] {
																		 100,
																		 0,
																		 0,
																		 0});
			this.numericUpDown5.ValueChanged += new System.EventHandler(this.numericUpDown5_ValueChanged);
			// 
			// numericUpDown6
			// 
			this.numericUpDown6.DecimalPlaces = 5;
			this.numericUpDown6.Increment = new System.Decimal(new int[] {
																			 1,
																			 0,
																			 0,
																			 327680});
			this.numericUpDown6.Location = new System.Drawing.Point(160, 120);
			this.numericUpDown6.Maximum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   131072});
			this.numericUpDown6.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   327680});
			this.numericUpDown6.Name = "numericUpDown6";
			this.numericUpDown6.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown6.TabIndex = 5;
			this.numericUpDown6.Value = new System.Decimal(new int[] {
																		 10,
																		 0,
																		 0,
																		 327680});
			this.numericUpDown6.ValueChanged += new System.EventHandler(this.numericUpDown6_ValueChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 23);
			this.label1.TabIndex = 6;
			this.label1.Text = "Vremenski korak deltaT";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(128, 23);
			this.label2.TabIndex = 7;
			this.label2.Text = "Reynoldsov broj";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(128, 23);
			this.label3.TabIndex = 8;
			this.label3.Text = "Relaksacija brzina";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 72);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(128, 23);
			this.label4.TabIndex = 9;
			this.label4.Text = "Relaksacija tlaka";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(24, 80);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(128, 23);
			this.label5.TabIndex = 10;
			this.label5.Text = "Maksimalni broj iteracija";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(24, 120);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(128, 23);
			this.label6.TabIndex = 11;
			this.label6.Text = "Uvjet konvergencije";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.numericUpDown2);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(248, 56);
			this.groupBox1.TabIndex = 12;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Postavke simulacije";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.numericUpDown3);
			this.groupBox2.Controls.Add(this.numericUpDown4);
			this.groupBox2.Location = new System.Drawing.Point(8, 72);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(248, 112);
			this.groupBox2.TabIndex = 13;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Skaliranje promjena";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.label1);
			this.groupBox3.Controls.Add(this.numericUpDown6);
			this.groupBox3.Controls.Add(this.label5);
			this.groupBox3.Controls.Add(this.label6);
			this.groupBox3.Controls.Add(this.numericUpDown1);
			this.groupBox3.Controls.Add(this.numericUpDown5);
			this.groupBox3.Location = new System.Drawing.Point(264, 8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(248, 176);
			this.groupBox3.TabIndex = 14;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Postavke iterativnog postupka";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(208, 192);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 23);
			this.button1.TabIndex = 15;
			this.button1.Text = "OK";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// FormPostavke
			// 
			this.AcceptButton = this.button1;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 229);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormPostavke";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Postavke";
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown6)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		// Promijeni Reynoldsov broj
		private void numericUpDown2_ValueChanged(object sender, System.EventArgs e)
		{
			solv.Re = (double)numericUpDown2.Value;
		}

		// Promijeni koeficijent relaksacije brzina
		private void numericUpDown3_ValueChanged(object sender, System.EventArgs e)
		{
			solv.velUndRelax = (double)numericUpDown3.Value;
		}

		// Promijeni koeficijent relaksacije tlaka
		private void numericUpDown4_ValueChanged(object sender, System.EventArgs e)
		{
			solv.pUndRel = (double)numericUpDown4.Value;
		}

		// Promijeni trajanje vremenskog koraka simulacije (diskretizacijske konstante vremena)
		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			solv.deltaT = (double)numericUpDown1.Value;
		}

		// Postavi maksimalni dopusteni broj iteracija iterativnih postupaka
		private void numericUpDown5_ValueChanged(object sender, System.EventArgs e)
		{
			solv.maxIteracija = (int)numericUpDown5.Value;
		}

		// Postavi uvjet konvergencije. Kada ispravke medu uzastopnim koracima postanu manje od ovoga
		// smatra se da je konvergencija postignuta
		private void numericUpDown6_ValueChanged(object sender, System.EventArgs e)
		{
			solv.convergenceCondition = (double)numericUpDown6.Value;
		}

		// Zatvori ovaj prozor
		private void button1_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}
}
